src/Entity/Partners.php
<?php

namespace App\Entity;

use App\Repository\PartnersRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: PartnersRepository::class)]
class Partners
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column]
    private ?bool $is_active = null;

    #[ORM\Column(length: 255)]
    private ?string $slug = null;

    #[ORM\ManyToOne(inversedBy: 'partners')]
    private ?Users $users = null;

    #[ORM\ManyToMany(targetEntity: Modules::class, inversedBy: 'partners')]
    private Collection $modules;

    #[ORM\Column(length: 100)]
    private ?string $name = null;

    #[ORM\OneToMany(mappedBy: 'partners', targetEntity: Structures::class)]
    private Collection $structures;

    public function __construct()
    {
        $this->modules = new ArrayCollection();
        $this->structures = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function isIsActive(): ?bool
    {
        return $this->is_active;
    }

    public function setIsActive(bool $is_active): self
    {
        $this->is_active = $is_active;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    public function getUsers(): ?Users
    {
        return $this->users;
    }

    public function setUsers(?Users $users): self
    {
        $this->users = $users;

        return $this;
    }

    /**
     * @return Collection<int, Modules>
     */
    public function getModules(): Collection
    {
        return $this->modules;
    }

    public function addModule(Modules $module): self
    {
        if (!$this->modules->contains($module)) {
            $this->modules->add($module);
        }

        return $this;
    }

    public function removeModule(Modules $module): self
    {
        $this->modules->removeElement($module);

        return $this;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    /**
     * @return Collection<int, Structures>
     */
    public function getStructures(): Collection
    {
        return $this->structures;
    }

    public function addStructure(Structures $structure): self
    {
        if (!$this->structures->contains($structure)) {
            $this->structures->add($structure);
            $structure->setPartners($this);
        }

        return $this;
    }

    public function removeStructure(Structures $structure): self
    {
        if ($this->structures->removeElement($structure)) {
            // set the owning side to null (unless already changed)
            if ($structure->getPartners() === $this) {
                $structure->setPartners(null);
            }
        }

        return $this;
    }
}

src/Form/PartnersType.php
<?php

namespace App\Form;

use App\Entity\Modules;
use App\Entity\Partners;
use App\Entity\Users;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class PartnersType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('is_active')
            ->add('name', TextType::class, [
                'required' => true,
                'label' => 'Nom du partenaire',
            ])
            ->add('slug')
            ->add('users', PersonType::class, [
                'data_class' => Users::class,
                'label' => 'Données du gérant',
            ])
            ->add('modules', EntityType::class, [
                'required' => true,
                'label' => 'Modules activés',
                'class' => Modules::class,
                'multiple' => true,
                'expanded' => true,
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Partners::class,
        ]);
    }
}

src/Controller/PartnersController.php
<?php

namespace App\Controller;

use App\Entity\Partners;
use App\Entity\Users;
use App\Form\PartnersType;
use App\Repository\PartnersRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

#[Route('admin/partners')]
class PartnersController extends AbstractController
{
    #[Route('/', name: 'app_partners_index', methods: ['GET'])]
    public function index(PartnersRepository $partnersRepository): Response
    {
        return $this->render('partners/index.html.twig', [
            'partners' => $partnersRepository->findAll(),
        ]);
    }

    #[Route('/new', name: 'app_partners_new', methods: ['GET', 'POST'])]
    public function new(Request $request, PartnersRepository $partnersRepository, EntityManagerInterface $entityManager): Response
    {
        $partner = new Partners();
        $form = $this->createForm(PartnersType::class, $partner);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            //on prend toute la partie qui est dans user
            $user = $form->get('users') -> getData();
            // dd($user -> getRolesUsers() -> getName());
            $r[]=$user -> getRolesUsers() -> getName();
            $user->setRoles($r);
            $entityManager->persist($form->get('users') -> getData());
            $partnersRepository->add($partner, true);
            //persiste    
            $user= new Users();    
            return $this->redirectToRoute('app_partners_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('partners/new.html.twig', [
            'partner' => $partner,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_partners_show', methods: ['GET'])]
    public function show(Partners $partner): Response
    {
        return $this->render('partners/show.html.twig', [
            'partner' => $partner,
        ]);
    }

    // Partners / Structures

    #[Route('/structures/{id}', name: 'app_partners_structures', methods: ['GET'])]
    public function showPartners(Partners $partner): Response
    {
        return $this->render('partners/show_structures.html.twig', [
            'partner' => $partner,
        ]);
    }
    

    #[Route('/{id}/edit', name: 'app_partners_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, Partners $partner, PartnersRepository $partnersRepository): Response
    {
        $form = $this->createForm(PartnersType::class, $partner);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $partnersRepository->add($partner, true);

            return $this->redirectToRoute('app_partners_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('partners/edit.html.twig', [
            'partner' => $partner,
            'user' => $partner->getUsers(),
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_partners_delete', methods: ['POST'])]
    public function delete(Request $request, Partners $partner, PartnersRepository $partnersRepository): Response
    {
        if ($this->isCsrfTokenValid('delete'.$partner->getId(), $request->request->get('_token'))) {
            $partnersRepository->remove($partner, true);
        }

        return $this->redirectToRoute('app_partners_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/partners/_delete_form.html.twig
<form method="post" action="{{ path('app_partners_delete', {'id': partner.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ partner.id) }}">
    <button class="btn delete"><i class="fa-solid fa-trash-can red"></i>Supprimer</button>
</form>

templates/partners/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn save mt-4 mb-4">{{ button_label|default('Sauvegarder') }}</button>
{{ form_end(form) }}

templates/partners/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Partners{% endblock %}

{% block body %}
    <h1>Éditer le Partenaire :  {{ partner.name }}</h1>

    {{ include('partners/_form.html.twig', {'button_label': 'Sauvegarder'}) }}

    <div class="pt-4">
        <i class="fa-solid fa-circle-arrow-left pl-3"></i>
        <a href="{{ path('app_partners_index') }}">Revenir à la liste</a>
    </div>

    {{ include('partners/_delete_form.html.twig') }}
{% endblock %}

templates/partners/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Liste des Partenaires{% endblock %}

{% block body %}
    <h1 class="py-5">Liste des <span class="heading-color">Partenaires</span></h1>

{# <div class="anim-typewriter">
  <h2 class="heading ">Liste des Partenaires</h2>
 </div> #}

    <div>
        <div class="search pb-5">
            <i id="icon" class="fas fa-search icon"></i> 
            <input id='searchid'></input>
        </div>
    </div>   

    <table class="table">
        <thead>
            <tr>
           
                <th>Nom</th>
                <th>Est actif</th>
                <th>Adresse Email</th>
                <th>Ville</th>
                <th>Modules activés</th>
                <th>Voir</th>
                <th>Modifier</th>
                <th>Supprimer</th>
                
            </tr>
        </thead>
        <tbody>
        {% for partner in partners %}
            <tr>

                <td>{{ partner.name }}</td>
                <td>{{ partner.isActive ? '<div class="on">Activé</div>' : '<div class="on">Désactivé</div>' }}</td>
                <td>{{ partner.users.email }}</td>
                <td>{{ partner.users.city }}</td>
                   <td>
                    {% if partner.Modules %}
                    {% for module in partner.Modules %}
                    {{module}}
                    {% endfor %}
                    {% endif %}
                </td>

                <td class="text-center">
                    <a href="{{ path('app_partners_show', {'id': partner.id}) }}"<i class="fa-solid fa-eye blue"></i> </a>
                </td>
                <td class="text-center">
                    <a href="{{ path('app_partners_edit', {'id': partner.id}) }}"><i class="fa-solid fa-pen purple"></i></a>
                </td>
                <td class="text-center">
                    <a href="{{ path('app_partners_delete', {'id': partner.id}) }}"><i class="fa-solid fa-trash-can red"></i></a></td>
                </tr>
        {% else %}
            <tr>
                <td colspan="4">Aucun résultat trouvé</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('app_partners_new') }}"><i class="fa-solid fa-plus green"></i> Créer un nouveau Partenaire</a>


{% endblock %}

templates/partners/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}Créer un nouveau Partenaire{% endblock %}

{% block body %}
    <h1>Créer un nouveau Partenaire</h1>

    {{ include('partners/_form.html.twig') }}

    <a href="{{ path('app_partners_index') }}">Revenir à la liste</a>
{% endblock %}

templates/partners/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Fiche partenaire {% endblock %}

{% block body %}
    <h1>Fiche Partenaire : {{ partner.name }}</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Est actif</th>
                <td>{{ partner.isActive ? 'Oui' : 'Non' }}</td>
            </tr>
            <tr>
                <th>Slug</th>
                <td>{{ partner.slug }}</td>
            </tr>
            <tr>
                <th>Modules</th>
                <td>
                    {% if partner.Modules %}
                    {% for module in partner.Modules %}
                    {{module}}
                    {% endfor %}
                    {% endif %}
                </td>
            </tr>    
        </tbody>
    </table>

    <div>
        <button class="btn modify-button mt-4"><a href="{{ path('app_partners_edit', {'id': partner.id}) }}">Modifier</a></button>
    </div>
    <div class="pt-4">
        <i class="fa-solid fa-circle-arrow-left pl-3"></i>
        <a href="{{ path('app_partners_index') }}">Revenir à la liste</a>
    </div>

    {# <button class="back-index"><a href="{{ path('app_partners_index') }}"><i class="fa-solid fa-person-walking-arrow-loop-left"></i>Revenir à la liste</a></button>

    <button class="edit"><a href="{{ path('app_partners_edit', {'id': partner.id}) }}"><i class="fa-solid fa-pen purple"></i>Modifier</a></button> #}

    {{ include('partners/_delete_form.html.twig') }}

{% endblock %}

templates/partners/show_structures.html.twig
{% extends 'base.html.twig' %}

{% block title %}Fiche partenaire {% endblock %}

{% block body %}
    <h1>Fiche Partenaire : {{ partner.name }}</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Structures</th>
                <td>
                    {% if partner.Structures %}
                    {% for structure in partner.Structures %}
                    {{structure.name}}
                    {% endfor %}
                    {% endif %}
                </td>
            </tr>    
        </tbody>
    </table>

    {# <div>
        <button class="btn modify-button mt-4"><a href="{{ path('app_partners_edit', {'id': partner.id}) }}">Modifier</a></button>
    </div>
    <div class="pt-4">
        <i class="fa-solid fa-circle-arrow-left pl-3"></i>
        <a href="{{ path('app_partners_index') }}">Revenir à la liste</a>
    </div> #}

    {# <button class="back-index"><a href="{{ path('app_partners_index') }}"><i class="fa-solid fa-person-walking-arrow-loop-left"></i>Revenir à la liste</a></button>

    <button class="edit"><a href="{{ path('app_partners_edit', {'id': partner.id}) }}"><i class="fa-solid fa-pen purple"></i>Modifier</a></button> #}

    {# {{ include('partners/_delete_form.html.twig') }} #}

{% endblock %}